#Bukley-James based on Y
#Y=a+dummy
library(MASS)
library(R2WinBUGS)

library(BRugs)
library(R2OpenBUGS)

library(Design)
library(Hmisc)

DukesA<-read.csv("C:/Users/Yoshiko Hayashi/Desktop/FinalR/R/GSE/dukes1.csv",header=T)
dim(DukesA)
Gene<-read.csv("C:/Users/Yoshiko Hayashi/Desktop/ESSEX/2013essex/survival/GSE143332.csv",header=T)
dim(Gene)


length(Gene[1,])
lGene<-array(NA, c(length(Gene[,1]), length(Gene[1,])))
dim(lGene)

for(i in 1:length(Gene[1,]))
{
for(j in 1:length(Gene[,1]))
{
 lGene[j,i]<-log(Gene[j,i])
}
}

dim(lGene)
TlGene<-t(lGene)
dim(TlGene)
dim(DukesA)
DukesAA<-cbind(TlGene,DukesA)
DukesA1<-na.exclude(DukesAA)
dim(DukesA1)

GGene<-DukesA1[,1:54613]
Dukes<-DukesA1$Dukes





table(Dukes)
#AB and CD
nd<-length(Dukes)
Dcell <- rep(0, nd)
Dcell[grep("C", as.character(Dukes))] <- 1
Dcell[grep("D", as.character(Dukes))] <- 1
Dcell




##############################################
GeneDATA<-cbind(DukesA1[1:54613],Dcell)
dim(GeneDATA)
#GeneDATA1<-na.exclude(GeneDATA)
Ngene<-length(GeneDATA[,1])
Ngene
#smG<-rep(0,10)

######################################################################
######################################################################
######################################################################
######################################################################
######################################################################
######################################################################

OBS<-matrix(rep(0,NNA*900), nrow=NNA, ncol=900, byrow=TRUE)

#NN<-1
NN<-1
####################################NN1<-54613
#NN1<-1000
NN1<-1000
NNA<-NN1-NN+1



########################################
BETA<-rep(0,NNA)
PM<-matrix(rep(0,NNA*290),nrow = NNA, ncol = 290, byrow = TRUE)
betadataC<-rep(0,2*290)
S2<-rep(0,NNA)
##########################################


D<-GeneDATA[,54614]

########################################
model<- function(){
  
  for (i in 2 : N - 1) { 
    for (j in 1 :i - 1){  
      Y.cv[i, j] <- Y[ j ]
      
    }
    for (j in i + 1 : N){ 
      Y.cv[i , j ] <- Y[j ]
    }  			
  }
  
  
  
  
  # omit case 1
  for (j in 2 : N) {
    Y.cv[1,j] <- Y[ j ]
  }
  # omit case N
  for (j in 1 : N - 1) {
    Y.cv[N,j] <- Y[ j ]
  }
  
  for(i in 1 : N){
    for (j in 1 : N) {
      
      Y.cv[i,j] ~ dt(mu[i,j], tau2, 15)                
      mu[i,j] <- beta[i,1]+beta[i,2]* D[j] 
      
    }
  }    
  
  
  
  
  for (i in 1:N){
    
    
    #Ycross[i]~dt(mu[i,i],taunew,3)
    Ycross[i]<-Y.cv[i,i]     
    mucross[i]<-mu[i,i]               
    
    
    
    
    
    
    pss2[i]<-Y[i]
    pss2new[i]<-Ycross[i]
    
    
    
    diff.mixed[i] <- pss2new[i] - pss2[i] 
    
    ####PM
    sp.mixed[i] <- step(diff.mixed[i])
    
    
    b2pos[i]<-beta[i,2]
    pb2[i]<-step(b2pos[i])
    
    
    
  } 
  
  
  
  s2<-pow(sd(Y[]),2)
  s2new<-pow(sd(Ycross[]),2)
  
  
  #####S2      
  s2ps<-step(s2new-s2)
  
  #p.mixed<-mean(sp.mixed[])
  
  for(i in 1:N ) {
    beta[i,1] ~ dflat( )
    beta[i,2] ~ dflat( )
    
  }
  
  tau2<-1/sigma2
  log(sigma2)<-2*tau
  tau~dflat()
  
  
}




file.name <- "C:/Users/Yoshiko Hayashi/Desktop/FinalR/R/GSE/PMnGSEfinal.txt"
write.model(model,file.name)




YY<-sample(1:54613,1000,replace=FALSE)

##############################################
for (i in 1:NNA)
{
N<-290
Y<-GeneDATA[,YY[i]]

data <- list ("D", "Y", "N")


#inits <- function(){list(beta=c(0, 0, 0), beta0 = 0)}
#inits <- function(){list( beta=c(0, 0, 0), beta0 = 0,log.sigma=c(1))}
#inits <- function(){list( beta=c(0,0) , tau=c(1))}
inits <- function(){list( beta=structure(.Data=c(betadataC),.Dim=c(290,2)),tau=c(1))}


test.sim <- bugs(data, inits,
model.file = "C:/Users/Yoshiko Hayashi/Desktop/FinalR/R/GSE/PMnGSEfinal.txt",
parameters = c( "sp.mixed","s2ps","beta","b2pos"),
n.chains=1,n.iter=1100,n.burnin=100,n.thin=1,
working.directory=getwd(),codaPkg=FALSE,debug=FALSE)

attach.bugs(test.sim)

#summary(beta)
#s2ps



#print(mean((beta[,2]<=0)*(beta[,1]<=0)))
#table(beta[,2]<=0)
#table(beta[,1]<=0)
#table((beta[,2]<=0)&(beta[,1]<=0))

#cov(beta[,2],beta[,1])

#OBS[i,]<-b3obs
BETA[i]<-mean(b2pos)



S2[i]<-mean(s2ps)



length(s2ps)
dim(sp.mixed)

dim(sp.mixed)
for(j in 1:N){
  PM[i,j]<-mean(sp.mixed[,j])
}

#######bugsSTOP##############
}

par(mfrow=c(2,2))
hist(S2, main="")

hist(PM, main="")
hist(BETA, main="")






#write(BETA, "GSEBETAT2.txt")
#write(S2, "GSES2T2.txt")
###########################################
FDR<-c(NN:NN1)
###########################################
for (i in NN:NN1)
{
#if (BETA[i]>0.5) {FDR[i]<-(1-BETA[i])}
#else {FDR[i]<-BETA[i]}
FDR[i]<-BETA[i]

}
lfdr<-sort(FDR)
#write(lfdr, "GSElfdrT2.txt")
###########################################
hist(lfdr[NN:NN1])

par(mfrow=c(1,2))
##############################

M<-length(S2)
pbg<-rep(0,M)
for (i in NN:NN1)
{
#if (BETA[i]>0.5) {pbg[i]<-(BETA[i])}
#else {pbg[i]<-(1-BETA[i])}
pbg[i]<-BETA[i]

}

pcut<-seq(0.5, 0.98, by=0.02)

R<-rep(0,25)
Spbg<-rep(0,25)
FDR<-rep(0,25)
for (j in 1:25)
{
for (i in NN:NN1)
{
if (pbg[i]>pcut[j])
 {R[j]<-R[j]+1
  Spbg[j]<-Spbg[j]+(1-pbg[i])
   }

}
}
#pbg
#R
#Spbg
#pcut
FDR<-Spbg/R
plot(pcut,FDR)
FDR



write(BETA,"C:/Users/Yoshiko Hayashi/Desktop/FinalR/R/GSE/Pbeta15n1000.txt")
write(S2,"C:/Users/Yoshiko Hayashi/Desktop/FinalR/R/GSE/PS2n15n1000.txt")
write(PM,"C:/Users/Yoshiko Hayashi/Desktop/FinalR/R/GSE/PM15n1000.txt")

par(mfrow=c(1,1))

hist(PM)
######################################################################
######################################################################
######################################################################
######################################################################
######################################################################
######################################################################


 