library(MASS)
library(R2WinBUGS)
library(BRugs)
library(R2OpenBUGS)

N=30

Dummy1 <- rep(0,15)
Dummy2 <- rep(1,15)
D<-c(Dummy1, Dummy2)
p<-c(1)

#######null#################################beta#####
#M1:nondifference(null)
M1<-900

############nonnull#################
#M2:difference(nonnull)
M2<-100

M<-M1+M2

########outliernull#####################################
M11<-M1-100

############outliernonnull#####################
M22<-M2-10

#10outlier
#############################################



#MODEL Y=beta0+beta1*Dummy
BETA<-c(1:M)
S2<-c(1:M)
BETApb1<-rep(0,M)
BETApb2<-rep(0,M)
BETApb3<-rep(0,M)
BETApb4<-rep(0,M)
BETApb5<-rep(0,M)
BETApb6<-rep(0,M)
BETApb7<-rep(0,M)
BETApb8<-rep(0,M)
BETApb9<-rep(0,M)
sd1<-1



##################non-null###############


Y1 <- c()
Y2 <- c()

Y11<-c()

for (i in 1:M22)
{
E11<-rt(15, 3)
E12<-rt(15, 3)


Y1 <- E11
Y2 <- 1+E12

Y11<-cbind(Y11,c(Y1,Y2))
}



OM2<-M22+1
for (i in OM2:M2)
{
E11<-rt(15, 3)
E12<-rt(15, 3)

OY1 <- E11
OY2 <- E12+1
OY1[1:2]<-OY1[1:2]+100
OY2[1:2]<-OY2[1:2]+100


Y11<-cbind(Y11,c(OY1,OY2))
}


#for (i in 1:100)

######null-data


E21<-c()
E22<-c()

Y221 <-c()
Y222 <-c()
Y22<-c(Y221,Y222)


for (i in 1:M11)
{
E21<-rt(15, 3)
E22<-rt(15, 3)

Y221 <- E21
Y222 <- E22



Y22<-cbind(Y22,c(Y221,Y222))

}
OM1<-M11+1
for (i in OM1:M1)
{
E21<-rt(15, 3)
E22<-rt(15, 3)

Y221 <- E21
Y222 <- E22

Y221[1:2]<-Y221[1:2]+100
Y222[1:2]<-Y222[1:2]+100


Y22<-cbind(Y22,c(Y221,Y222))

}



Y<-cbind(Y11,Y22)




N<-30

MM<-M
N
dim(Y)
dim(X)

YT<-t(Y) 
XT<-t(D)



dim(YT)

mss<-rep(0,M)


MM3<-MM*2
betadata<-rep(0,MM3)
mudata<-rep(0,MM)
taudata<-rep(1,MM)
betadataAA<-rep(0,MM3)
betadataC<-rep(0,2)

length(betadata)
BETA2<-matrix(rep(0,M*N), nrow = M, ncol = N, byrow = TRUE)
BETA<-rep(0,M)
#################################################################
BETApb1<-rep(0,M)
#################################################################

PM<-matrix(rep(0,M*N),nrow = M, ncol = N, byrow = TRUE)

############BUGS#####################
model<- function(){
  
  for (j in 1 : N) {
    
    YD[j] ~ dt(mu[j], tau2, 3)                
    mu[j] <- beta[1]+beta[2] * D[j]
    Ycross[j] ~ dt(mu[j], tau2, 3)
    
    s22[j]<-pow((YD[j]),2)
    s2new2[j]<-pow((Ycross[j]),2)
    
  }
  
  
  for (i in 1 : N) {
    
    
    diff.mixed[i] <- Ycross[i] - YD[i] 
    
    ####PM
    sp.mixed[i] <- step(diff.mixed[i])
  }
  
  b2pos<-step(beta[2])
  
  pb1<-step(abs(beta[2])-1.0)
  pb2<-step(abs(beta[2])-1.1)
  pb3<-step(abs(beta[2])-1.2)
  pb4<-step(abs(beta[2])-1.3)
  pb5<-step(abs(beta[2])-1.4)
  pb6<-step(abs(beta[2])-1.5)
  pb7<-step(abs(beta[2])-1.6)
  pb8<-step(abs(beta[2])-1.7)
  pb9<-step(abs(beta[2])-1.8)
  
  
 
  s2<-pow(sd(YD[]),2)
  s2new<-pow(sd(Ycross[]),2)
  
  
  #####S2      
  s2ps<-step(s2new-s2)
  
  #p.mixed<-mean(sp.mixed[])

  beta[1] ~ dflat( )
  beta[2] ~ dflat( )
  
  tau2<-1/sigma2
  log(sigma2)<-2*tau
  tau~dflat()
  
  
}



file.name <- "cut1.txt"
write.model(model,file.name)

############BUGS#####################

for (i in 1:M)
{

YD<-Y[,i]

data <- list ("D", "YD", "N")
####crossE1&crossA####
inits <- function(){list( beta=c(0,0),tau=c(1))}

test.sim <- bugs(data, inits,
 model.file = "cut1.txt",
 parameters = c( "sp.mixed","s2ps","beta","b2pos","pb1","pb2","pb3","pb4","pb5","pb6","pb7","pb8","pb9"),
n.chains=1,n.iter=10000,n.burnin=1000,n.thin=5,
working.directory=getwd(),codaPkg=FALSE,debug=FALSE)

attach.bugs(test.sim)


BETA[i]<-mean(b2pos)


BETApb1[i]<-mean(pb1)
BETApb2[i]<-mean(pb2)
BETApb3[i]<-mean(pb3)
BETApb4[i]<-mean(pb4)
BETApb5[i]<-mean(pb5)
BETApb6[i]<-mean(pb6)
BETApb7[i]<-mean(pb7)
BETApb8[i]<-mean(pb8)
BETApb9[i]<-mean(pb9)

S2[i]<-mean(s2ps)



length(s2ps)
dim(sp.mixed)

dim(sp.mixed)
for(j in 1:N){
PM[i,j]<-mean(sp.mixed[,j])
}

#######bugsSTOP##############
}

par(mfrow=c(2,2))
hist(S2, main="")

hist(PM, main="")
hist(BETA, main="")


write(BETApb1, "pb1SIM1.txt")
write(BETApb2, "pb2SIM1.txt")
write(BETApb3, "pb3SIM1.txt")
write(BETApb4, "pb4SIM1.txt")
write(BETApb5, "pb5SIM1.txt")
write(BETApb6, "pb6SIM1.txt")
write(BETApb7, "pb7SIM1.txt")
write(BETApb8, "pb8SIM1.txt")
write(BETApb9, "pb9SIM1.txt")

sum(BETApb1)
sum(BETApb2)
sum(BETApb3)
sum(BETApb4)
sum(BETApb5)
sum(BETApb6)
sum(BETApb7)
sum(BETApb8)
sum(BETApb9)



