library(MASS)
library(R2WinBUGS)
library(BRugs)
library(R2OpenBUGS)

N=30


Dummy1 <- rep(0,15)
Dummy2 <- rep(1,15)
D<-c(Dummy1, Dummy2)
p<-c(1)


model<- function(){
  
  for (i in 2 : N - 1) { 
    for (j in 1 :i - 1){  
      Y.cv[i, j] <- YD[ j ]
      
    }
    for (j in i + 1 : N){ 
      Y.cv[i , j ] <- YD[j ]
    }  			
  }
  
  
  
  
  # omit case 1
  for (j in 2 : N) {
    Y.cv[1,j] <- YD[ j ]
  }
  # omit case N
  for (j in 1 : N - 1) {
    Y.cv[N,j] <- YD[ j ]
  }
  
  for(i in 1 : N){
    for (j in 1 : N) {
      
      Y.cv[i,j] ~ dt(mu[i,j], tau2, 3)                
      mu[i,j] <- beta[i,1]+beta[i,2]* D[j] 
      
    }
  }    
  
  
  
  
  for (i in 1:N){

    
    Ycross[i]<-Y.cv[i,i]     
    mucross[i]<-mu[i,i]               
    

    
    pss2[i]<-YD[i]
    pss2new[i]<-Ycross[i]
    
    
    
    diff.mixed[i] <- pss2new[i] - pss2[i] 
    
    ####PM
    sp.mixed[i] <- step(diff.mixed[i])
    
    
    b2pos[i]<-beta[i,2]
    pb2[i]<-step(b2pos[i])
    
    
    
  } 
  
  
 
  s2<-pow(sd(YD[]),2)
  s2new<-pow(sd(Ycross[]),2)
  
  
  #####S2      
  s2ps<-step(s2new-s2)
  
  #p.mixed<-mean(sp.mixed[])

  for(i in 1:N ) {
    beta[i,1] ~ dflat( )
    beta[i,2] ~ dflat( )
    
  }
  
  tau2<-1/sigma2
  log(sigma2)<-2*tau
  tau~dflat()
  
  
}



file.name <- "C:/Users/Yoshiko Hayashi/Desktop/FinalR/R/cross/nPfig2.txt"
write.model(model,file.name)

############BUGS#####################
betadataC<-rep(0,N*2)

